function estad = estadistica(msgbin,orden)
% Sistemas de Comunicacin 2013 - Taller
% Instituto de Ingeniera Elctrica
%
%  estad = estadistica(msgbin)
%
% funcion que calcula la estadistica de un mensaje p-ario {0,1,p} (puede se
% un mensaje binario con borrones {0,1,2}) y la devuelve en el vector 
% estad = [p(0),p(1),p(2),..,p(k)]
%
%  Se le puede pasar el orden, para que calcule la estadistica considerando
%  el mensaje proveniente de una fuente de orden: "orden".
%
%nota: msgbin puede ser un mensaje binario pero con "borrones" (o sea no es
%      binario es triario 0 1 2. 

if nargin < 2
 orden = 1;
end

%msgbin = str2num(msgbin);

lmsg = length(msgbin);

%-----------------------------------
borron = 2; %me fijo si hay borrones
ind = find(msgbin == borron);
if ~isempty(ind)
    msgbin(ind) = 2^orden; %El borron lo marco como el valor mas alto.
    k = 2^orden;
else
     k = 2^orden-1;
end
%----------------------------------

msgshape = reshape(msgbin,orden,lmsg/orden)';
cbase = 2.^[orden-1:-1:0];
msgC = msgshape*cbase';

ind = find(msgC > 2^orden - 1);
msgC(ind) = 2^orden;

estad = [];

for i = 1:k+1
    estad(i) = length(find(msgC== i-1));
end

%Normalizo
estad = orden*estad/lmsg;

