function codhuff = huffman(p)
% Sistemas de Comunicacin 2013 - Taller
% Instituto de Ingeniera Elctrica
%
% FUNCTION codhuff = huffman(p)
%
% Dado el vector de probabilidades devuelve un c�digo de huffman (�ptimo) que contiene la distribucion de probabilidadas conjuntas
% 
%
%
% Andre Luiz Fonseca de Oliveira, Alicia Fern�ndez
% 03-07-97
% 
% Adaptado por mdelbra
% 05-03-06

%-------------------------------------------------------------------------
%Busco simbolos con estadistica nula y les adjudico un valor epsilon para
%que el codigo funcione.
epsilon = 0.0000001;
ind = find(p==0);
for i = 1:length(ind)
    [maximo,j] = max(p); 
    p(ind(i))=epsilon;
    p(j) = p(j) - epsilon;
end
clear ind;
clear maximo;
clear j;
%-------------------------------------------------------------------------

[m n] = size(p);
if (m * n) ~= max([m n])
	error('p debe ser un vector')
end
if (m == 1)
	p = p';
end

if (max([m n]) == 1)
	codhuff = '0';
elseif (max([m n]) == 2)
	codhuff = ['0'; '1']
else

	[aux_p, aux_ind] = sort(p);
	A(:,1) = aux_p;
	ind(:,1) = aux_ind;
	n=max(size(p));
	largo_cod_max = n - 1;

	for i=1:largo_cod_max
		cod_sal(1,i) = ' ';
	end;

	for i=2:n
		cod_sal(i,:) = cod_sal(1,:);
	end


	for i=2:n-1
		aux_p = zeros(n, 1);
		aux_p(i) = A(i-1,i-1) + A(i,i-1);
		for j=(i+1):n
			aux_p(j) = A(j,i-1);
		end
		aux_ind = find(aux_p > 0);
		[aux_p, aux_ind] = sort(aux_p(aux_ind));
		A(i:n,i) = aux_p;
		ind(i:n,i) = aux_ind;
	end
	cod_sal(n-1,1) = '1';
	cod_sal(n,1) = '0';
	for i=(n-2):-1:1
		aux_p = A((i+1):n,(i+1));
		aux_ind = ind((i+1):n,(i+1));
		aux_p(aux_ind) = aux_p;
		A((i+1):n,(i+1)) = aux_p;
		aux_cod = cod_sal((i+1):n,:);
		aux_cod(aux_ind,:) = aux_cod;
		cod_sal((i+1):n,:) = aux_cod;
		cod_sal(i,:) = cod_sal((i+1),:);
		pos = cod_sal(i,:);
		pos = find(pos == ' ');
		pos = pos(1);
		cod_sal(i,pos) = '0';
		cod_sal((i+1),pos) = '1';
	end
	aux_p = A(:,1);
	aux_ind = ind(:,1);
	A(aux_ind,1) = aux_p;
	cod_sal(aux_ind,:) = cod_sal;
end
prob = A;
codhuff = cod_sal;
