function [msgbin,msgtxt] = texto2bin(archivotxt,archivobin)
% Sistemas de Comunicacin 2013 - Taller
% Instituto de Ingeniera Elctrica
%
%     msgbin = texto2bin(archivotxt)
%
% Funcion que leer un archivo de texto ASCII y lo convierte a binario.
%
% msgbin     <-- Mensaje codificado en binario
% archivotxt --> Archivo txt que contiene el mensaje (texto plano)
% archivobin --> (Opcional) Archivo txt que contiene el mensaje binario (texto plano)

fid=fopen(archivotxt);
file=fread(fid);
fclose(fid);
fuente = dec2bin(file,8)';
lmsgbin = size(fuente,1)*size(fuente,2);
msgbin = reshape(fuente,lmsgbin,1);

char0 = 48;
msgbin = abs(msgbin)-char0;

if nargin > 1
  texto_bin = char(msgbin + char0);
  fid=fopen(archivobin,'wb');
  fwrite(fid,texto_bin);
  %fwrite(fid,msgbin);
  fclose(fid);
end

if nargout > 1
     msgtxt = char(file);
end
